- Elementary
- Main
- Authors
- Examples
- Files
- Pages
- Types
- Modules

Enumerations | Functions
Genlist

## Enumerations
enum | Elm_Gengrid_Item_Scrollto_Type { ELM_GENGRID_ITEM_SCROLLTO_NONE = 0, ELM_GENGRID_ITEM_SCROLLTO_IN = (1 << 0), ELM_GENGRID_ITEM_SCROLLTO_TOP = (1 << 1), ELM_GENGRID_ITEM_SCROLLTO_MIDDLE = (1 << 2) }
| Defines where to position the item in the genlist. More...
enum | Elm_Genlist_Item_Type { ELM_GENLIST_ITEM_NONE = 0, ELM_GENLIST_ITEM_TREE = (1 << 0), ELM_GENLIST_ITEM_GROUP = (1 << 1) }
| Defines if the item is of any special type (has subitems or it's the index of a group), or is just a simple item. More...
enum | Elm_Genlist_Item_Field_Type
| Defines the type of the item part Used while updating item's parts It can be used at updating multi fields.
enum | Elm_Genlist_Item_Scrollto_Type { ELM_GENLIST_ITEM_SCROLLTO_NONE = 0, ELM_GENLIST_ITEM_SCROLLTO_IN = (1 << 0), ELM_GENLIST_ITEM_SCROLLTO_TOP = (1 << 1), ELM_GENLIST_ITEM_SCROLLTO_MIDDLE = (1 << 2) }
| Defines where to position the item in the genlist. More...

## Functions
EINA_DEPRECATED void | elm_genlist_bounce_set (Evas_Object *obj, Eina_Bool h_bounce, Eina_Bool v_bounce)
| Enable/disable horizontal and vertical bouncing effect. More...
EINA_DEPRECATED void | elm_genlist_bounce_get (const Evas_Object *obj, Eina_Bool *h_bounce, Eina_Bool *v_bounce)
| Get whether the horizontal and vertical bouncing effect is enabled. More...
EINA_DEPRECATED void | elm_genlist_scroller_policy_set (Evas_Object *obj, Elm_Scroller_Policy policy_h, Elm_Scroller_Policy policy_v)
| Set the scrollbar policy. More...
EINA_DEPRECATED void | elm_genlist_scroller_policy_get (const Evas_Object *obj, Elm_Scroller_Policy *policy_h, Elm_Scroller_Policy *policy_v)
| Get the scrollbar policy. More...
Elm_Object_Item * | elm_genlist_item_next_get (const Elm_Object_Item *it)
| Get the next item in a genlist widget's internal list of items, given a handle to one of those items. More...
Elm_Object_Item * | elm_genlist_item_prev_get (const Elm_Object_Item *it)
| Get the previous item in a genlist widget's internal list of items, given a handle to one of those items. More...
void | elm_genlist_item_selected_set (Elm_Object_Item *it, Eina_Bool selected)
| Set whether a given genlist item is selected or not. More...
Eina_Bool | elm_genlist_item_selected_get (const Elm_Object_Item *it)
| Get whether a given genlist item is selected or not. More...
void | elm_genlist_item_show (Elm_Object_Item *it, Elm_Genlist_Item_Scrollto_Type type)
| Show the portion of a genlist's internal list containing a given item, immediately. More...
void | elm_genlist_item_bring_in (Elm_Object_Item *it, Elm_Genlist_Item_Scrollto_Type type)
| Animatedly bring in, to the visible area of a genlist, a given item on it. More...
void | elm_genlist_item_update (Elm_Object_Item *it)
| Update all the contents of an item. More...
void | elm_genlist_item_item_class_update (Elm_Object_Item *it, const Elm_Genlist_Item_Class *itc)
| Update the item class of an item. More...
const Elm_Genlist_Item_Class * | elm_genlist_item_item_class_get (const Elm_Object_Item *it)
| Get the Genlist Item class for the given Genlist Item. More...
int | elm_genlist_item_index_get (const Elm_Object_Item *it)
| Get the index of the item. More...
Elm_Genlist_Item_Class * | elm_genlist_item_class_new (void)
| Create a new genlist item class in a given genlist widget. More...
void | elm_genlist_item_class_free (Elm_Genlist_Item_Class *itc)
| Remove an item class in a given genlist widget. More...
void | elm_genlist_item_class_ref (Elm_Genlist_Item_Class *itc)
| Increments object reference count for the item class. More...
void | elm_genlist_item_class_unref (Elm_Genlist_Item_Class *itc)
| Decrements object reference count for the item class. More...
void | elm_genlist_item_tooltip_text_set (Elm_Object_Item *it, const char *text)
| Set the text to be shown in a given genlist item's tooltips. More...
void | elm_genlist_item_tooltip_content_cb_set (Elm_Object_Item *it, Elm_Tooltip_Item_Content_Cb func, const void *data, Evas_Smart_Cb del_cb)
| Set the content to be shown in a given genlist item's tooltips. More...
void | elm_genlist_item_tooltip_unset (Elm_Object_Item *it)
| Unset a tooltip from a given genlist item. More...
void | elm_genlist_item_tooltip_style_set (Elm_Object_Item *it, const char *style)
| Set a different style for a given genlist item's tooltip. More...
const char * | elm_genlist_item_tooltip_style_get (const Elm_Object_Item *it)
| Get the style set a given genlist item's tooltip. More...
void | elm_genlist_item_cursor_set (Elm_Object_Item *it, const char *cursor)
| Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given genlist widget item. More...
const char * | elm_genlist_item_cursor_get (const Elm_Object_Item *it)
| Get the type of mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given genlist widget item. More...
void | elm_genlist_item_cursor_unset (Elm_Object_Item *it)
| Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given genlist widget item, thus making it show the default cursor again. More...
void | elm_genlist_item_cursor_style_set (Elm_Object_Item *it, const char *style)
| Set a different style for a given custom cursor set for a genlist item. More...
const char * | elm_genlist_item_cursor_style_get (const Elm_Object_Item *it)
| Get the current style set for a given genlist item's custom cursor. More...
void | elm_genlist_item_cursor_engine_only_set (Elm_Object_Item *it, Eina_Bool engine_only)
| Set if the (custom) cursor for a given genlist item should be searched in its theme, also, or should only rely on the rendering engine. More...
Eina_Bool | elm_genlist_item_cursor_engine_only_get (const Elm_Object_Item *it)
| Get if the (custom) cursor for a given genlist item is being searched in its theme, also, or is only relying on the rendering engine. More...
Elm_Object_Item * | elm_genlist_item_parent_get (const Elm_Object_Item *it)
| Get the parent item of the given item. More...
void | elm_genlist_item_subitems_clear (Elm_Object_Item *it)
| Remove all sub-items (children) of the given item. More...
void | elm_genlist_item_expanded_set (Elm_Object_Item *it, Eina_Bool expanded)
| Sets the expanded state of an item. More...
Eina_Bool | elm_genlist_item_expanded_get (const Elm_Object_Item *it)
| Get the expanded state of an item. More...
int | elm_genlist_item_expanded_depth_get (const Elm_Object_Item *it)
| Get the depth of expanded item. More...
void | elm_genlist_item_all_contents_unset (Elm_Object_Item *it, Eina_List **l)
| Unset all contents fetched by the item class. More...
void | elm_genlist_item_promote (Elm_Object_Item *it)
| Promote an item to the top of the list. More...
void | elm_genlist_item_demote (Elm_Object_Item *it)
| Demote an item to the end of the list. More...
void | elm_genlist_item_fields_update (Elm_Object_Item *it, const char *parts, Elm_Genlist_Item_Field_Type itf)
| Update the part of an item. More...
void | elm_genlist_item_decorate_mode_set (Elm_Object_Item *it, const char *decorate_it_type, Eina_Bool decorate_it_set)
| Activate a genlist mode on an item. More...
const char * | elm_genlist_item_decorate_mode_get (const Elm_Object_Item *it)
| Get the item's decorate mode. More...
Elm_Genlist_Item_Type | elm_genlist_item_type_get (const Elm_Object_Item *it)
| Get the Item's Type. More...
void | elm_genlist_item_flip_set (Elm_Object_Item *it, Eina_Bool flip)
| Set the flip state of a given genlist item. More...
Eina_Bool | elm_genlist_item_flip_get (const Elm_Object_Item *it)
| Get the flip state of a given genlist item. More...
void | elm_genlist_item_select_mode_set (Elm_Object_Item *it, Elm_Object_Select_Mode mode)
| Set the genlist item's select mode. More...
Elm_Object_Select_Mode | elm_genlist_item_select_mode_get (const Elm_Object_Item *it)
| Get the genlist item's select mode. More...
Evas_Object * | elm_genlist_add (Evas_Object *parent)
| Add a new genlist widget to the given parent Elementary (container) object. More...
void | elm_genlist_clear (Evas_Object *obj)
| Remove all items from a given genlist widget. More...
void | elm_genlist_multi_select_set (Evas_Object *obj, Eina_Bool multi)
| Enable or disable multi-selection in the genlist. More...
Eina_Bool | elm_genlist_multi_select_get (const Evas_Object *obj)
| Get if multi-selection in genlist is enabled or disabled. More...
void | elm_genlist_multi_select_mode_set (Evas_Object *obj, Elm_Object_Multi_Select_Mode mode)
| Set the genlist multi select mode. More...
Elm_Object_Multi_Select_Mode | elm_genlist_multi_select_mode_get (const Evas_Object *obj)
| Get the genlist multi select mode. More...
void | elm_genlist_mode_set (Evas_Object *obj, Elm_List_Mode mode)
| This sets the horizontal stretching mode. More...
Elm_List_Mode | elm_genlist_mode_get (const Evas_Object *obj)
| Get the horizontal stretching mode. More...
Elm_Object_Item * | elm_genlist_item_append (Evas_Object *obj, const Elm_Genlist_Item_Class *itc, const void *data, Elm_Object_Item *parent, Elm_Genlist_Item_Type type, Evas_Smart_Cb func, const void *func_data)
| Append a new item in a given genlist widget. More...
Elm_Object_Item * | elm_genlist_item_prepend (Evas_Object *obj, const Elm_Genlist_Item_Class *itc, const void *data, Elm_Object_Item *parent, Elm_Genlist_Item_Type type, Evas_Smart_Cb func, const void *func_data)
| Prepend a new item in a given genlist widget. More...
Elm_Object_Item * | elm_genlist_item_insert_before (Evas_Object *obj, const Elm_Genlist_Item_Class *itc, const void *data, Elm_Object_Item *parent, Elm_Object_Item *before, Elm_Genlist_Item_Type type, Evas_Smart_Cb func, const void *func_data)
| Insert an item before another in a genlist widget. More...
Elm_Object_Item * | elm_genlist_item_insert_after (Evas_Object *obj, const Elm_Genlist_Item_Class *itc, const void *data, Elm_Object_Item *parent, Elm_Object_Item *after, Elm_Genlist_Item_Type type, Evas_Smart_Cb func, const void *func_data)
| Insert an item after another in a genlist widget. More...
Elm_Object_Item * | elm_genlist_item_sorted_insert (Evas_Object *obj, const Elm_Genlist_Item_Class *itc, const void *data, Elm_Object_Item *parent, Elm_Genlist_Item_Type type, Eina_Compare_Cb comp, Evas_Smart_Cb func, const void *func_data)
| Insert a new item into the sorted genlist object. More...
Elm_Object_Item * | elm_genlist_selected_item_get (const Evas_Object *obj)
| Get the selected item in the genlist. More...
const Eina_List * | elm_genlist_selected_items_get (const Evas_Object *obj)
| Get a list of selected items in the genlist. More...
Eina_List * | elm_genlist_realized_items_get (const Evas_Object *obj)
| Get a list of realized items in genlist. More...
Elm_Object_Item * | elm_genlist_first_item_get (const Evas_Object *obj)
| Get the first item in the genlist. More...
Elm_Object_Item * | elm_genlist_last_item_get (const Evas_Object *obj)
| Get the last item in the genlist. More...
void | elm_genlist_realized_items_update (Evas_Object *obj)
| Update the contents of all realized items. More...
unsigned int | elm_genlist_items_count (const Evas_Object *obj)
| Return how many items are currently in a list. More...
void | elm_genlist_homogeneous_set (Evas_Object *obj, Eina_Bool homogeneous)
| Enable/disable homogeneous mode. More...
Eina_Bool | elm_genlist_homogeneous_get (const Evas_Object *obj)
| Get whether the homogeneous mode is enabled. More...
void | elm_genlist_block_count_set (Evas_Object *obj, int count)
| Set the maximum number of items within an item block. More...
int | elm_genlist_block_count_get (const Evas_Object *obj)
| Get the maximum number of items within an item block. More...
void | elm_genlist_longpress_timeout_set (Evas_Object *obj, double timeout)
| Set the timeout in seconds for the longpress event. More...
double | elm_genlist_longpress_timeout_get (const Evas_Object *obj)
| Get the timeout in seconds for the longpress event. More...
Elm_Object_Item * | elm_genlist_at_xy_item_get (const Evas_Object *obj, Evas_Coord x, Evas_Coord y, int *posret)
| Get the item that is at the x, y canvas coords. More...
Elm_Object_Item * | elm_genlist_decorated_item_get (const Evas_Object *obj)
| Get active genlist mode item. More...
void | elm_genlist_reorder_mode_set (Evas_Object *obj, Eina_Bool reorder_mode)
| Set reorder mode. More...
Eina_Bool | elm_genlist_reorder_mode_get (const Evas_Object *obj)
| Get the reorder mode. More...
void | elm_genlist_decorate_mode_set (Evas_Object *obj, Eina_Bool decorated)
| Set Genlist decorate mode. More...
Eina_Bool | elm_genlist_decorate_mode_get (const Evas_Object *obj)
| Get Genlist decorate mode. More...
void | elm_genlist_tree_effect_enabled_set (Evas_Object *obj, Eina_Bool enabled)
| Set Genlist tree effect. More...
Eina_Bool | elm_genlist_tree_effect_enabled_get (const Evas_Object *obj)
| Get Genlist tree effect. More...
void | elm_genlist_select_mode_set (Evas_Object *obj, Elm_Object_Select_Mode mode)
| Set the genlist select mode. More...
Elm_Object_Select_Mode | elm_genlist_select_mode_get (const Evas_Object *obj)
| Get the genlist select mode. More...
void | elm_genlist_highlight_mode_set (Evas_Object *obj, Eina_Bool highlight)
| Set whether the genlist items' should be highlighted when item selected. More...
Eina_Bool | elm_genlist_highlight_mode_get (const Evas_Object *obj)
| Get whether the genlist items' should be highlighted when item selected. More...
void | elm_genlist_focus_on_selection_set (Evas_Object *obj, Eina_Bool enabled)
| Set focus upon items selection mode. More...
Eina_Bool | elm_genlist_focus_on_selection_get (const Evas_Object *obj)
| Get whether focus upon item's selection mode is enabled. More...
#define | elm_obj_genlist_items_count(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEMS_COUNT), EO_TYPECHECK(unsigned int *, ret)
#define | elm_obj_genlist_item_append(itc, data, parent, type, func, func_data, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_APPEND), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_item_prepend(itc, data, parent, type, func, func_data, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_PREPEND), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_item_insert_after(itc, data, parent, after_it, type, func, func_data, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_INSERT_AFTER), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Object_Item *, after_it), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_item_insert_before(itc, data, parent, before_it, type, func, func_data, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_INSERT_BEFORE), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Object_Item *, before_it), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_item_sorted_insert(itc, data, parent, type, comp, func, func_data, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_SORTED_INSERT), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Eina_Compare_Cb, comp), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_clear() ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_CLEAR)
#define | elm_obj_genlist_multi_select_set(multi) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_SET), EO_TYPECHECK(Eina_Bool, multi)
#define | elm_obj_genlist_multi_select_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_multi_select_mode_set(mode) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode, mode)
#define | elm_obj_genlist_multi_select_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode *, ret)
#define | elm_obj_genlist_selected_item_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECTED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_selected_items_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECTED_ITEMS_GET), EO_TYPECHECK(const Eina_List **, ret)
#define | elm_obj_genlist_realized_items_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REALIZED_ITEMS_GET), EO_TYPECHECK(Eina_List **, ret)
#define | elm_obj_genlist_at_xy_item_get(x, y, posret, ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_AT_XY_ITEM_GET), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y), EO_TYPECHECK(int *, posret), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_first_item_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FIRST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_last_item_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LAST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_mode_set(mode) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MODE_SET), EO_TYPECHECK(Elm_List_Mode, mode)
#define | elm_obj_genlist_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MODE_GET), EO_TYPECHECK(Elm_List_Mode *, ret)
#define | elm_obj_genlist_homogeneous_set(homogeneous) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HOMOGENEOUS_SET), EO_TYPECHECK(Eina_Bool, homogeneous)
#define | elm_obj_genlist_homogeneous_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HOMOGENEOUS_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_block_count_set(count) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_BLOCK_COUNT_SET), EO_TYPECHECK(int, count)
#define | elm_obj_genlist_block_count_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_BLOCK_COUNT_GET), EO_TYPECHECK(int *, ret)
#define | elm_obj_genlist_longpress_timeout_set(timeout) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LONGPRESS_TIMEOUT_SET), EO_TYPECHECK(double, timeout)
#define | elm_obj_genlist_longpress_timeout_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LONGPRESS_TIMEOUT_GET), EO_TYPECHECK(double *, ret)
#define | elm_obj_genlist_realized_items_update() ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REALIZED_ITEMS_UPDATE)
#define | elm_obj_genlist_decorated_item_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_genlist_decorate_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATE_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_decorate_mode_set(decorated) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATE_MODE_SET), EO_TYPECHECK(Eina_Bool, decorated)
#define | elm_obj_genlist_reorder_mode_set(reorder_mode) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REORDER_MODE_SET), EO_TYPECHECK(Eina_Bool, reorder_mode)
#define | elm_obj_genlist_reorder_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REORDER_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_select_mode_set(mode) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Select_Mode, mode)
#define | elm_obj_genlist_select_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Select_Mode *, ret)
#define | elm_obj_genlist_highlight_mode_set(highlight) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HIGHLIGHT_MODE_SET), EO_TYPECHECK(Eina_Bool, highlight)
#define | elm_obj_genlist_highlight_mode_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HIGHLIGHT_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_tree_effect_enabled_set(enabled) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_TREE_EFFECT_ENABLED_SET), EO_TYPECHECK(Eina_Bool, enabled)
#define | elm_obj_genlist_tree_effect_enabled_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_TREE_EFFECT_ENABLED_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_genlist_focus_on_selection_set(enabled) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FOCUS_ON_SELECTION_SET), EO_TYPECHECK(Eina_Bool, enabled)
#define | elm_obj_genlist_focus_on_selection_get(ret) ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FOCUS_ON_SELECTION_GET), EO_TYPECHECK(Eina_Bool *, ret)

## Detailed Description

This widget aims to have more expansive list than the simple list in Elementary that could have more flexible items and allow many more entries while still being fast and low on memory usage. At the same time it was also made to be able to do tree structures. But the price to pay is more complexity when it comes to usage. If all you want is a simple list with icons and a single text, use the normal List object.

Genlist has a fairly large API, mostly because it's relatively complex, trying to be both expansive, powerful and efficient. First we will begin an overview on the theory behind genlist.

This widget inherits from the Layout one, so that all the functions acting on it also work for genlist objects.

This widget implements the elm-scrollable-interface interface, so that all (non-deprecated) functions for the base Scroller widget also work for genlists.

Some calls on the genlist's API are marked as deprecated, as they just wrap the scrollable widgets counterpart functions. Use the ones we point you to, for each case of deprecation here, instead – eventually the deprecated ones will be discarded (next major release).

# Genlist item classes - creating items

In order to have the ability to add and delete items on the fly, genlist implements a class (callback) system where the application provides a structure with information about that type of item (genlist may contain multiple different items with different classes, states and styles). Genlist will call the functions in this struct (methods) when an item is "realized" (i.e., created dynamically, while the user is scrolling the list). All objects will simply be deleted when no longer needed with evas_object_del(). The #Elm_Genlist_Item_Class structure contains the following members:

- `item_style` - This is a constant string and simply defines the name of the item style. It must be specified and the default should be `"default"`.
- `decorate_item_style` - This is a constant string and simply defines the name of the decorate mode item style. It is used to specify decorate mode item style. It can be used when you call elm_genlist_item_decorate_mode_set().
- `decorate_all_item_style` - This is a constant string and simply defines the name of the decorate all item style. It is used to specify decorate all item style. It can be used to set selection, checking and deletion mode. This is used when you call elm_genlist_decorate_mode_set().
- `func` - A struct with pointers to functions that will be called when an item is going to be actually created. All of them receive a `data` parameter that will point to the same data passed to elm_genlist_item_append() and related item creation functions, and an `obj` parameter that points to the genlist object itself.

The function pointers inside `func` are `text_get`, `content_get`, `state_get` and `del`. The 3 first functions also receive a `part` parameter described below. A brief description of these functions follows:

- `text_get` - The `part` parameter is the name string of one of the existing text parts in the Edje group implementing the item's theme. This function must return a strdup'()ed string, as the caller will free() it when done. See #Elm_Genlist_Item_Text_Get_Cb.
- `content_get` - The `part` parameter is the name string of one of the existing (content) swallow parts in the Edje group implementing the item's theme. It must return `NULL`, when no content is desired, or a valid object handle, otherwise. The object will be deleted by the genlist on its deletion or when the item is "unrealized". See #Elm_Genlist_Item_Content_Get_Cb.
- `func.state_get` - The `part` parameter is the name string of one of the state parts in the Edje group implementing the item's theme. Return `EINA_FALSE` for false/off or `EINA_TRUE` for true/on. Genlists will emit a signal to its theming Edje object with `"elm,state,xxx,active"` and `"elm"` as "emission" and "source" arguments, respectively, when the state is true (the default is false), where `xxx` is the name of the (state) part. See #Elm_Genlist_Item_State_Get_Cb.
- `func.del` - This is intended for use when genlist items are deleted, so any data attached to the item (e.g. its data parameter on creation) can be deleted. See #Elm_Genlist_Item_Del_Cb.

available item styles:

- default
- default_style - The text part is a textblock

- double_label

- icon_top_text_bottom

- group_index

- one_icon - Only 1 icon (left) (since 1.7)
- end_icon - Only 1 icon (at end/right) (since 1.7)
- no_icon - No icon (at end/right) (since 1.7)
- full - Only 1 icon, elm.swallow.content, which consumes whole area of genlist itemj (since 1.7)

If one wants to use more icons and texts than are offered in theme, there are two solutions. One is to use 'full' style that has one big swallow part. You can swallow anything there. The other solution is to customize genlist item style in application side by using elm_theme_extension_add() and its own edc. Please refer Theme - Using extensions for that.

# Structure of items

An item in a genlist can have 0 or more texts (they can be regular text or textblock Evas objects - that's up to the style to determine), 0 or more contents (which are simply objects swallowed into the genlist item's theming Edje object) and 0 or more boolean states, which have the behavior left to the user to define. The Edje part names for each of these properties will be looked up, in the theme file for the genlist, under the Edje (string) data items named `"labels"`, `"contents"` and `"states"`, respectively. For each of those properties, if more than one part is provided, they must have names listed separated by spaces in the data fields. For the default genlist item theme, we have one text part (`"elm.text"`), two content parts (`"elm.swalllow.icon"` and `"elm.swallow.end"`) and no state parts.

A genlist item may be at one of several styles. Elementary provides one by default - "default", but this can be extended by system or application custom themes/overlays/extensions (see themes for more details).

# Editing and Navigating

Items can be added by several calls. All of them return a Elm_Object_Item handle that is an internal member inside the genlist. They all take a data parameter that is meant to be used for a handle to the applications internal data (eg. the struct with the original item data). The parent parameter is the parent genlist item this belongs to if it is a tree or an indexed group, and NULL if there is no parent. The flags can be a bitmask of ELM_GENLIST_ITEM_NONE, ELM_GENLIST_ITEM_TREE and ELM_GENLIST_ITEM_GROUP. If ELM_GENLIST_ITEM_TREE is set then this item is displayed as an item that is able to expand and have child items. If ELM_GENLIST_ITEM_GROUP is set then this item is group index item that is displayed at the top until the next group comes. The func parameter is a convenience callback that is called when the item is selected and the data parameter will be the func_data parameter, `obj` be the genlist object and event_info will be the genlist item.

elm_genlist_item_append() adds an item to the end of the list, or if there is a parent, to the end of all the child items of the parent. elm_genlist_item_prepend() is the same but adds to the beginning of the list or children list. elm_genlist_item_insert_before() inserts at item before another item and elm_genlist_item_insert_after() inserts after the indicated item.

The application can clear the list with elm_genlist_clear() which deletes all the items in the list and elm_object_item_del() will delete a specific item. elm_genlist_item_subitems_clear() will clear all items that are children of the indicated parent item.

To help inspect list items you can jump to the item at the top of the list with elm_genlist_first_item_get() which will return the item pointer, and similarly elm_genlist_last_item_get() gets the item at the end of the list. elm_genlist_item_next_get() and elm_genlist_item_prev_get() get the next and previous items respectively relative to the indicated item. Using these calls you can walk the entire item list/tree. Note that as a tree the items are flattened in the list, so elm_genlist_item_parent_get() will let you know which item is the parent (and thus know how to skip them if wanted).

# Multi-selection

If the application wants multiple items to be able to be selected, elm_genlist_multi_select_set() can enable this. If the list is single-selection only (the default), then elm_genlist_selected_item_get() will return the selected item, if any, or NULL if none is selected. If the list is multi-select then elm_genlist_selected_items_get() will return a list (that is only valid as long as no items are modified (added, deleted, selected or unselected)).

# Usage hints

There are also convenience functions. elm_object_item_widget_get() will return the genlist object the item belongs to. elm_genlist_item_show() will make the scroller scroll to show that specific item so its visible. elm_object_item_data_get() returns the data pointer set by the item creation functions.

If an item changes (state of boolean changes, text or contents change), then use elm_genlist_item_update() to have genlist update the item with the new state. Genlist will re-realize the item and thus call the functions in the _Elm_Genlist_Item_Class for that item.

To programmatically (un)select an item use elm_genlist_item_selected_set(). To get its selected state use elm_genlist_item_selected_get(). Similarly to expand/contract an item and get its expanded state, use elm_genlist_item_expanded_set() and elm_genlist_item_expanded_get(). And again to make an item disabled (unable to be selected and appear differently) use elm_object_item_disabled_set() to set this and elm_object_item_disabled_get() to get the disabled state.

In general to indicate how the genlist should expand items horizontally to fill the list area, use elm_genlist_mode_set(). Valid modes are ELM_LIST_LIMIT, ELM_LIST_COMPRESS and ELM_LIST_SCROLL. The default is ELM_LIST_SCROLL. This mode means that if items are too wide to fit, the scroller will scroll horizontally. Otherwise items are expanded to fill the width of the viewport of the scroller. If it is ELM_LIST_LIMIT, items will be expanded to the viewport width if larger than the item, but genlist widget witdh is limited to the largest item. Do not use ELM_LIST_LIMIT mode with homogenous mode turned on. ELM_LIST_COMPRESS can be combined with a different style that uses edjes' ellipsis feature (cutting text off like this: "tex...").

Items will call their selection func and callback only once when first becoming selected. Any further clicks will do nothing, unless you enable always select with elm_genlist_select_mode_set() as ELM_OBJECT_SELECT_MODE_ALWAYS. This means even if selected, every click will make the selected callbacks be called. elm_genlist_select_mode_set() as ELM_OBJECT_SELECT_MODE_NONE will turn off the ability to select items entirely and they will neither appear selected nor call selected callback functions.

Remember that you can create new styles and add your own theme augmentation per application with elm_theme_extension_add(). If you absolutely must have a specific style that overrides any theme the user or system sets up you can use elm_theme_overlay_add() to add such a file.

# Implementation

Evas tracks every object you create. Every time it processes an event (mouse move, down, up etc.) it needs to walk through objects and find out what event that affects. Even worse every time it renders display updates, in order to just calculate what to re-draw, it needs to walk through many many many objects. Thus, the more objects you keep active, the more overhead Evas has in just doing its work. It is advisable to keep your active objects to the minimum working set you need. Also remember that object creation and deletion carries an overhead, so there is a middle-ground, which is not easily determined. But don't keep massive lists of objects you can't see or use. Genlist does this with list objects. It creates and destroys them dynamically as you scroll around. It groups them into blocks so it can determine the visibility etc. of a whole block at once as opposed to having to walk the whole list. This 2-level list allows for very large numbers of items to be in the list (tests have used up to 2,000,000 items). Also genlist employs a queue for adding items. As items may be different sizes, every item added needs to be calculated as to its size and thus this presents a lot of overhead on populating the list, this genlist employs a queue. Any item added is queued and spooled off over time, actually appearing some time later, so if your list has many members you may find it takes a while for them to all appear, with your process consuming a lot of CPU while it is busy spooling.

Genlist also implements a tree structure for items, but it does so with callbacks to the application, with the application filling in tree structures when requested (allowing for efficient building of a very deep tree that could even be used for file-management). See the above smart signal callbacks for details.

# Genlist smart events

This widget emits the following signals, besides the ones sent from Layout:

- `"activated"` - The user has double-clicked or pressed (enter|return|spacebar) on an item. The `event_info` parameter is the item that was activated.
- `"pressed"` - The user pressed the an item. The `event_info` parameter is the item that was pressed.
- `"released"` - The user released the an item. The `event_info` parameter is the item that was released.
- `"clicked,double"` - The user has double-clicked an item. The `event_info` parameter is the item that was double-clicked.
- `"selected"` - This is called when a user has made an item selected. The event_info parameter is the genlist item that was selected.
- `"unselected"` - This is called when a user has made an item unselected. The event_info parameter is the genlist item that was unselected.
- `"expanded"` - This is called when elm_genlist_item_expanded_set() is called and the item is now meant to be expanded. The event_info parameter is the genlist item that was indicated to expand. It is the job of this callback to then fill in the child items.
- `"contracted"` - This is called when elm_genlist_item_expanded_set() is called and the item is now meant to be contracted. The event_info parameter is the genlist item that was indicated to contract. It is the job of this callback to then delete the child items.
- `"expand,request"` - This is called when a user has indicated they want to expand a tree branch item. The callback should decide if the item can expand (has any children) and then call elm_genlist_item_expanded_set() appropriately to set the state. The event_info parameter is the genlist item that was indicated to expand.
- `"contract,request"` - This is called when a user has indicated they want to contract a tree branch item. The callback should decide if the item can contract (has any children) and then call elm_genlist_item_expanded_set() appropriately to set the state. The event_info parameter is the genlist item that was indicated to contract.
- `"realized"` - This is called when the item in the list is created as a real evas object. event_info parameter is the genlist item that was created.
- `"unrealized"` - This is called just before an item is unrealized. After this call content objects provided will be deleted and the item object itself delete or be put into a floating cache.
- `"drag,start,up"` - This is called when the item in the list has been dragged (not scrolled) up.
- `"drag,start,down"` - This is called when the item in the list has been dragged (not scrolled) down.
- `"drag,start,left"` - This is called when the item in the list has been dragged (not scrolled) left.
- `"drag,start,right"` - This is called when the item in the list has been dragged (not scrolled) right.
- `"drag,stop"` - This is called when the item in the list has stopped being dragged.
- `"drag"` - This is called when the item in the list is being dragged.
- `"longpressed"` - This is called when the item is pressed for a certain amount of time. By default it's 1 second. The event_info parameter is the longpressed genlist item.
- `"scroll,anim,start"` - This is called when scrolling animation has started.
- `"scroll,anim,stop"` - This is called when scrolling animation has stopped.
- `"scroll,drag,start"` - This is called when dragging the content has started.
- `"scroll,drag,stop"` - This is called when dragging the content has stopped.
- `"edge,top"` - This is called when the genlist is scrolled until the top edge.
- `"edge,bottom"` - This is called when the genlist is scrolled until the bottom edge.
- `"edge,left"` - This is called when the genlist is scrolled until the left edge.
- `"edge,right"` - This is called when the genlist is scrolled until the right edge.
- `"multi,swipe,left"` - This is called when the genlist is multi-touch swiped left.
- `"multi,swipe,right"` - This is called when the genlist is multi-touch swiped right.
- `"multi,swipe,up"` - This is called when the genlist is multi-touch swiped up.
- `"multi,swipe,down"` - This is called when the genlist is multi-touch swiped down.
- `"multi,pinch,out"` - This is called when the genlist is multi-touch pinched out.
- `"multi,pinch,in"` - This is called when the genlist is multi-touch pinched in.
- `"swipe"` - This is called when the genlist is swiped.
- `"moved"` - This is called when a genlist item is moved by a user interaction in a reorder mode. The c event_info parameter is the item that was moved.
- `"moved,after"` - This is called when a genlist item is moved after another item in reorder mode. The event_info parameter is the reordered item. To get the relative previous item, use elm_genlist_item_prev_get(). This signal is called along with "moved" signal.
- `"moved,before"` - This is called when a genlist item is moved before another item in reorder mode. The event_info parameter is the reordered item. To get the relative previous item, use elm_genlist_item_next_get(). This signal is called along with "moved" signal.
- `"index,update"` - This is called when a genlist item index is changed. Note that this callback is called while each item is being realized.
- `"language,changed"` - This is called when the program's language is changed. Call the elm_genlist_realized_items_update() if items text should be translated.
- `"tree,effect,finished"` - This is called when a genlist tree effect is finished.
- `"highlighted"` - an item in the list is highlighted. This is called when the user presses an item or keyboard selection is done so the item is physically highlighted. The c event_info parameter is the item that was highlighted.
- `"unhighlighted"` - an item in the list is unhighlighted. This is called when the user releases an item or keyboard selection is moved so the item is physically unhighlighted. The c event_info parameter is the item that was unhighlighted.
- `"focused"` - When the genlist has received focus. (since 1.8)
- `"unfocused"` - When the genlist has lost focus. (since 1.8)

Supported elm_object_item common APIs

- elm_object_item_part_content_get
- elm_object_item_part_text_get
- elm_object_item_disabled_set
- elm_object_item_disabled_get
- elm_object_item_signal_emit

Unsupported elm_object_item common APIs due to the genlist concept. Genlist fills content/text according to the appropriate callback functions. Please use elm_genlist_item_update() or elm_genlist_item_fields_update() instead.

- elm_object_item_part_content_set
- elm_object_item_part_content_unset
- elm_object_item_part_text_set

# Examples

Here is a list of examples that use the genlist, trying to show some of its capabilities:

- Genlist - basic usage
- Genlist - list setup functions
- Genlist - different width options
- Genlist - items manipulation
- Genlist - working with subitems

## Macro Definition Documentation

#define elm_obj_genlist_at_xy_item_get | ( |  | x,
|  |  | y,
|  |  | posret,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_AT_XY_ITEM_GET), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y), EO_TYPECHECK(int *, posret), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the item that is at the x, y canvas coords.

Parameters

  [in] | x |
  [in] | y |
  [out] | posret |
  [out] | ret |

See Also
  elm_genlist_at_xy_item_get

Referenced by elm_genlist_at_xy_item_get().

#define elm_obj_genlist_block_count_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_BLOCK_COUNT_GET), EO_TYPECHECK(int *, ret)

Since
  1.8

Get the maximum number of items within an item block

Parameters

  [out] | ret |

See Also
  elm_genlist_block_count_get

Referenced by elm_genlist_block_count_get().

#define elm_obj_genlist_block_count_set | ( |  | count | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_BLOCK_COUNT_SET), EO_TYPECHECK(int, count)

Since
  1.8

Set the maximum number of items within an item block

Parameters

  [in] | count |

See Also
  elm_genlist_block_count_set

Referenced by elm_genlist_block_count_set().

#define elm_obj_genlist_clear | ( |  | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_CLEAR)

Since
  1.8

Remove all items from a given genlist widget.

See Also
  elm_genlist_clear

Referenced by elm_genlist_clear().

#define elm_obj_genlist_decorate_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATE_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get Genlist decorate mode

Parameters

  [out] | ret |

See Also
  elm_genlist_decorate_mode_get

Referenced by elm_genlist_decorate_mode_get().

#define elm_obj_genlist_decorate_mode_set | ( |  | decorated | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATE_MODE_SET), EO_TYPECHECK(Eina_Bool, decorated)

Since
  1.8

Set Genlist decorate mode

Parameters

  [in] | decorated |

See Also
  elm_genlist_decorate_mode_set

Referenced by elm_genlist_decorate_mode_set().

#define elm_obj_genlist_decorated_item_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_DECORATED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get active genlist mode item

Parameters

  [out] | ret |

See Also
  elm_genlist_decorated_item_get

Referenced by elm_genlist_decorated_item_get().

#define elm_obj_genlist_first_item_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FIRST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the first item in the genlist

Parameters

  [out] | ret |

See Also
  elm_genlist_first_item_get

Referenced by elm_genlist_first_item_get().

#define elm_obj_genlist_focus_on_selection_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FOCUS_ON_SELECTION_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether the focus will be set to a widget on an item upon it's selection.

Parameters

  [out] | ret |

See Also
  elm_obj_genlist_focus_on_selection_set

Referenced by elm_genlist_focus_on_selection_get().

#define elm_obj_genlist_focus_on_selection_set | ( |  | enabled | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_FOCUS_ON_SELECTION_SET), EO_TYPECHECK(Eina_Bool, enabled)

Since
  1.8

Set focus to a first from left focusable widget upon item selection.

Parameters

  [in] | enabled |

See Also
  elm_obj_genlist_focus_on_selection_get

Referenced by elm_genlist_focus_on_selection_set().

#define elm_obj_genlist_highlight_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HIGHLIGHT_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether the genlist items' should be highlighted when item selected.

Parameters

  [out] | ret |

See Also
  elm_genlist_highlight_mode_get

Referenced by elm_genlist_highlight_mode_get().

#define elm_obj_genlist_highlight_mode_set | ( |  | highlight | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HIGHLIGHT_MODE_SET), EO_TYPECHECK(Eina_Bool, highlight)

Since
  1.8

Set whether the genlist items' should be highlighted when item selected.

Parameters

  [in] | highlight |

See Also
  elm_genlist_highlight_mode_set

Referenced by elm_genlist_highlight_mode_set().

#define elm_obj_genlist_homogeneous_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HOMOGENEOUS_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether the homogeneous mode is enabled.

Parameters

  [out] | ret |

See Also
  elm_genlist_homogeneous_get

Referenced by elm_genlist_homogeneous_get().

#define elm_obj_genlist_homogeneous_set | ( |  | homogeneous | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_HOMOGENEOUS_SET), EO_TYPECHECK(Eina_Bool, homogeneous)

Since
  1.8

Enable/disable homogeneous mode.

Parameters

  [in] | homogeneous |

See Also
  elm_genlist_homogeneous_set

Referenced by elm_genlist_homogeneous_set().

#define elm_obj_genlist_item_append | ( |  | itc,
|  |  | data,
|  |  | parent,
|  |  | type,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_APPEND), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Append a new item in a given genlist widget.

Parameters

  [in] | itc |
  [in] | data |
  [in] | parent |
  [in] | type |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_genlist_item_append

Referenced by elm_genlist_item_append().

#define elm_obj_genlist_item_insert_after | ( |  | itc,
|  |  | data,
|  |  | parent,
|  |  | after_it,
|  |  | type,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_INSERT_AFTER), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Object_Item *, after_it), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert an item after another in a genlist widget

Parameters

  [in] | itc |
  [in] | data |
  [in] | parent |
  [in] | after_it |
  [in] | type |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_genlist_item_insert_after

Referenced by elm_genlist_item_insert_after().

#define elm_obj_genlist_item_insert_before | ( |  | itc,
|  |  | data,
|  |  | parent,
|  |  | before_it,
|  |  | type,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_INSERT_BEFORE), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Object_Item *, before_it), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert an item before another in a genlist widget

Parameters

  [in] | itc |
  [in] | data |
  [in] | parent |
  [in] | before_it |
  [in] | type |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_genlist_item_insert_before

Referenced by elm_genlist_item_insert_before().

#define elm_obj_genlist_item_prepend | ( |  | itc,
|  |  | data,
|  |  | parent,
|  |  | type,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_PREPEND), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Prepend a new item in a given genlist widget.

Parameters

  [in] | itc |
  [in] | data |
  [in] | parent |
  [in] | type |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_genlist_item_prepend

Referenced by elm_genlist_item_prepend().

#define elm_obj_genlist_item_sorted_insert | ( |  | itc,
|  |  | data,
|  |  | parent,
|  |  | type,
|  |  | comp,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEM_SORTED_INSERT), EO_TYPECHECK(const Elm_Genlist_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, parent), EO_TYPECHECK(Elm_Genlist_Item_Type, type), EO_TYPECHECK(Eina_Compare_Cb, comp), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert a new item into the sorted genlist object

Parameters

  [in] | itc |
  [in] | data |
  [in] | parent |
  [in] | type |
  [in] | comp |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_genlist_item_sorted_insert

Referenced by elm_genlist_item_sorted_insert().

#define elm_obj_genlist_items_count | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_ITEMS_COUNT), EO_TYPECHECK(unsigned int *, ret)

Since
  1.8

Return how many items are currently in a list

Parameters

  [out] | ret |

See Also
  elm_genlist_items_count

Referenced by elm_genlist_items_count().

#define elm_obj_genlist_last_item_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LAST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the last item in the genlist

Parameters

  [out] | ret |

See Also
  elm_genlist_last_item_get

Referenced by elm_genlist_last_item_get().

#define elm_obj_genlist_longpress_timeout_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LONGPRESS_TIMEOUT_GET), EO_TYPECHECK(double *, ret)

Since
  1.8

Get the timeout in seconds for the longpress event.

Parameters

  [out] | ret |

See Also
  elm_genlist_longpress_timeout_get

Referenced by elm_genlist_longpress_timeout_get().

#define elm_obj_genlist_longpress_timeout_set | ( |  | timeout | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_LONGPRESS_TIMEOUT_SET), EO_TYPECHECK(double, timeout)

Since
  1.8

Set the timeout in seconds for the longpress event.

Parameters

  [in] | timeout |

See Also
  elm_genlist_longpress_timeout_set

Referenced by elm_genlist_longpress_timeout_set().

#define elm_obj_genlist_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MODE_GET), EO_TYPECHECK(Elm_List_Mode *, ret)

Since
  1.8

Get the horizontal stretching mode.

Parameters

  [out] | ret |

See Also
  elm_genlist_mode_get

Referenced by elm_genlist_mode_get().

#define elm_obj_genlist_mode_set | ( |  | mode | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MODE_SET), EO_TYPECHECK(Elm_List_Mode, mode)

Since
  1.8

This sets the horizontal stretching mode.

Parameters

  [in] | mode |

See Also
  elm_genlist_mode_set

Referenced by elm_genlist_mode_set().

#define elm_obj_genlist_multi_select_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get if multi-selection in genlist is enabled or disabled.

Parameters

  [out] | ret |

See Also
  elm_genlist_multi_select_get

Referenced by elm_genlist_multi_select_get().

#define elm_obj_genlist_multi_select_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode *, ret)

Since
  1.8

Get the genlist multi select mode.

Parameters

  [out] | ret | (If getting mode is failed, it returns ELM_OBJECT_MULTI_SELECT_MODE_MAX)

See Also
  elm_genlist_multi_select_set()
  elm_genlist_multi_select_mode_set()

Referenced by elm_genlist_multi_select_mode_get().

#define elm_obj_genlist_multi_select_mode_set | ( |  | mode | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode, mode)

Since
  1.8

Set the genlist multi select mode.

Parameters

  [in] | mode | ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT : select/unselect items whenever each item is clicked. ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL : Only one item will be selected although multi-selection is enabled, if clicked without pressing control key. This mode is only available with multi-selection.

See Also
  elm_genlist_multi_select_set()
  elm_genlist_multi_select_mode_get()

Referenced by elm_genlist_multi_select_mode_set().

#define elm_obj_genlist_multi_select_set | ( |  | multi | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_MULTI_SELECT_SET), EO_TYPECHECK(Eina_Bool, multi)

Since
  1.8

Enable or disable multi-selection in the genlist

Parameters

  [in] | multi |

See Also
  elm_genlist_multi_select_set

Referenced by elm_genlist_multi_select_set().

#define elm_obj_genlist_realized_items_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REALIZED_ITEMS_GET), EO_TYPECHECK(Eina_List **, ret)

Since
  1.8

Get a list of realized items in genlist

Parameters

  [out] | ret |

See Also
  elm_genlist_realized_items_get

Referenced by elm_genlist_realized_items_get().

#define elm_obj_genlist_realized_items_update | ( |  | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REALIZED_ITEMS_UPDATE)

Since
  1.8

Update the contents of all realized items.

See Also
  elm_genlist_realized_items_update

Referenced by elm_genlist_realized_items_update().

#define elm_obj_genlist_reorder_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REORDER_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get the reorder mode

Parameters

  [out] | ret |

See Also
  elm_genlist_reorder_mode_get

Referenced by elm_genlist_reorder_mode_get().

#define elm_obj_genlist_reorder_mode_set | ( |  | reorder_mode | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_REORDER_MODE_SET), EO_TYPECHECK(Eina_Bool, reorder_mode)

Since
  1.8

Set reorder mode

Parameters

  [in] | reorder_mode |

See Also
  elm_genlist_reorder_mode_set

Referenced by elm_genlist_reorder_mode_set().

#define elm_obj_genlist_select_mode_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Select_Mode *, ret)

Since
  1.8

Get the genlist select mode.

Parameters

  [out] | ret |

See Also
  elm_genlist_select_mode_get

Referenced by elm_genlist_select_mode_get().

#define elm_obj_genlist_select_mode_set | ( |  | mode | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Select_Mode, mode)

Since
  1.8

Set the genlist select mode.

Parameters

  [in] | mode |

See Also
  elm_genlist_select_mode_set

Referenced by elm_genlist_select_mode_set().

#define elm_obj_genlist_selected_item_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECTED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the selected item in the genlist.

Parameters

  [out] | ret |

See Also
  elm_genlist_selected_item_get

Referenced by elm_genlist_selected_item_get().

#define elm_obj_genlist_selected_items_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_SELECTED_ITEMS_GET), EO_TYPECHECK(const Eina_List **, ret)

Since
  1.8

Get a list of selected items in the genlist.

Parameters

  [out] | ret |

See Also
  elm_genlist_selected_items_get

Referenced by elm_genlist_selected_items_get().

#define elm_obj_genlist_tree_effect_enabled_get | ( |  | ret | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_TREE_EFFECT_ENABLED_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get Genlist tree effect

Parameters

  [out] | ret |

See Also
  elm_genlist_tree_effect_enabled_get

Referenced by elm_genlist_tree_effect_enabled_get().

#define elm_obj_genlist_tree_effect_enabled_set | ( |  | enabled | ) | ELM_OBJ_GENLIST_ID(ELM_OBJ_GENLIST_SUB_ID_TREE_EFFECT_ENABLED_SET), EO_TYPECHECK(Eina_Bool, enabled)

Since
  1.8

Set Genlist tree effect

Parameters

  [in] | enabled |

See Also
  elm_genlist_tree_effect_enabled_set

Referenced by elm_genlist_tree_effect_enabled_set().

## Enumeration Type Documentation

enum Elm_Gengrid_Item_Scrollto_Type

Defines where to position the item in the genlist.

Enumerator
ELM_GENGRID_ITEM_SCROLLTO_NONE | no scrollto
ELM_GENGRID_ITEM_SCROLLTO_IN | to the nearest viewport
ELM_GENGRID_ITEM_SCROLLTO_TOP | to the top of viewport
ELM_GENGRID_ITEM_SCROLLTO_MIDDLE | to the middle of viewport

enum Elm_Genlist_Item_Scrollto_Type

Defines where to position the item in the genlist.

Enumerator
ELM_GENLIST_ITEM_SCROLLTO_NONE | no scrollto
ELM_GENLIST_ITEM_SCROLLTO_IN | to the nearest viewport
ELM_GENLIST_ITEM_SCROLLTO_TOP | to the top of viewport
ELM_GENLIST_ITEM_SCROLLTO_MIDDLE | to the middle of viewport

enum Elm_Genlist_Item_Type

Defines if the item is of any special type (has subitems or it's the index of a group), or is just a simple item.

Enumerator
ELM_GENLIST_ITEM_NONE | simple item
ELM_GENLIST_ITEM_TREE | this may be expanded and have child items.
ELM_GENLIST_ITEM_GROUP | an index item of a group of items. this item can have child items.

## Function Documentation

Evas_Object* elm_genlist_add | ( | Evas_Object * | parent | ) |

Add a new genlist widget to the given parent Elementary (container) object.

Parameters

  parent | The parent object

Returns
  a new genlist widget handle or `NULL`, on errors

This function inserts a new genlist widget on the canvas.

See Also
  elm_genlist_item_append()
  elm_object_item_del()
  elm_genlist_clear()

Elm_Object_Item* elm_genlist_at_xy_item_get | ( | const Evas_Object * | obj,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | int * | posret
| ) |  |

Get the item that is at the x, y canvas coords.

Parameters

  obj | The genlist object.
  x | The input x coordinate
  y | The input y coordinate
  posret | The position relative to the item returned here

Returns
  The item at the coordinates or NULL if none

This returns the item at the given coordinates (which are canvas relative, not object-relative). If an item is at that coordinate, that item handle is returned, and if `posret` is not NULL, the integer pointed to is set to a value of -1, 0 or 1, depending if the coordinate is on the upper portion of that item (-1), on the middle section (0) or on the lower part (1). If NULL is returned as an item (no item found there), then posret may indicate -1 or 1 based if the coordinate is above or below all items respectively in the genlist.

References elm_obj_genlist_at_xy_item_get.

int elm_genlist_block_count_get | ( | const Evas_Object * | obj | ) |

Get the maximum number of items within an item block.

Parameters

  obj | The genlist object

Returns
  Maximum number of items within an item block

See Also
  elm_genlist_block_count_set()

References elm_obj_genlist_block_count_get.

void elm_genlist_block_count_set | ( | Evas_Object * | obj,
|  | int | count
| ) |  |

Set the maximum number of items within an item block.

Parameters

  obj | The genlist object
  count | Maximum number of items within an item block. Default is 32.

This will configure the block count to tune to the target with particular performance matrix.

A block of objects will be used to reduce the number of operations due to many objects in the screen. It can determine the visibility, or if the object has changed, it theme needs to be updated, etc. doing this kind of calculation to the entire block, instead of per object.

The default value for the block count is enough for most lists, so unless you know you will have a lot of objects visible in the screen at the same time, don't try to change this.

See Also
  elm_genlist_block_count_get()
  Implementation

References elm_obj_genlist_block_count_set.

EINA_DEPRECATED void elm_genlist_bounce_get | ( | const Evas_Object * | obj,
|  | Eina_Bool * | h_bounce,
|  | Eina_Bool * | v_bounce
| ) |  |

Get whether the horizontal and vertical bouncing effect is enabled.

Parameters

  obj | The genlist object
  h_bounce | Pointer to a bool to receive if the bounce horizontally option is set.
  v_bounce | Pointer to a bool to receive if the bounce vertically option is set.

Deprecated:
  Use elm_scroller_bounce_get() instead.

See Also
  elm_scroller_bounce_get()
  elm_genlist_bounce_set()

References elm_scrollable_interface_bounce_allow_get.

EINA_DEPRECATED void elm_genlist_bounce_set | ( | Evas_Object * | obj,
|  | Eina_Bool | h_bounce,
|  | Eina_Bool | v_bounce
| ) |  |

Enable/disable horizontal and vertical bouncing effect.

Parameters

  obj | The genlist object
  h_bounce | Allow bounce horizontally (`EINA_TRUE` = on, `EINA_FALSE` = off). Default is `EINA_FALSE`.
  v_bounce | Allow bounce vertically (`EINA_TRUE` = on, `EINA_FALSE` = off). Default is `EINA_TRUE`.

This will enable or disable the scroller bouncing effect for the genlist. See elm_scroller_bounce_set() for details.

Deprecated:
  Use elm_scroller_bounce_set() instead.

See Also
  elm_scroller_bounce_set()
  elm_genlist_bounce_get()

References elm_scrollable_interface_bounce_allow_set.

void elm_genlist_clear | ( | Evas_Object * | obj | ) |

Remove all items from a given genlist widget.

Parameters

  obj | The genlist object

This removes (and deletes) all items in `obj`, leaving it empty.

See Also
  elm_object_item_del(), to remove just one item.

References elm_obj_genlist_clear.

Referenced by elm_store_free(), and elm_store_target_genlist_set().

Eina_Bool elm_genlist_decorate_mode_get | ( | const Evas_Object * | obj | ) |

Get Genlist decorate mode.

Parameters

  obj | The genlist object

Returns
  The decorate mode status (EINA_TRUE = decorate mode, EINA_FALSE = normal mode

References elm_obj_genlist_decorate_mode_get.

void elm_genlist_decorate_mode_set | ( | Evas_Object * | obj,
|  | Eina_Bool | decorated
| ) |  |

Set Genlist decorate mode.

This sets Genlist decorate mode to all items.

Parameters

  obj | The Genlist object
  decorated | The decorate mode status (EINA_TRUE = decorate mode, EINA_FALSE = normal mode

References elm_obj_genlist_decorate_mode_set.

Elm_Object_Item* elm_genlist_decorated_item_get | ( | const Evas_Object * | obj | ) |

Get active genlist mode item.

Parameters

  obj | The genlist object

Returns
  The active item for that current mode. Or `NULL` if no item is activated with any mode.

This function returns the item that was activated with a mode, by the function elm_genlist_item_decorate_mode_set().

See Also
  elm_genlist_item_decorate_mode_set()
  elm_genlist_mode_get()

References elm_obj_genlist_decorated_item_get.

Elm_Object_Item* elm_genlist_first_item_get | ( | const Evas_Object * | obj | ) |

Get the first item in the genlist.

This returns the first item in the list.

Parameters

  obj | The genlist object

Returns
  The first item, or NULL if none

References elm_obj_genlist_first_item_get.

Referenced by elm_genlist_item_promote().

Eina_Bool elm_genlist_focus_on_selection_get | ( | const Evas_Object * | obj | ) |

Get whether focus upon item's selection mode is enabled.

Parameters

  obj | The genlist object

Returns
  The tree effect status (EINA_TRUE = enabled, EINA_FALSE = disabled)

References elm_obj_genlist_focus_on_selection_get.

void elm_genlist_focus_on_selection_set | ( | Evas_Object * | obj,
|  | Eina_Bool | enabled
| ) |  |

Set focus upon items selection mode.

Parameters

  obj | The genlist object
  enabled | The tree effect status (EINA_TRUE = enabled, EINA_FALSE = disabled)

When enabled, every selection of an item inside the genlist will automatically set focus to its first focusable widget from the left. This is true of course if the selection was made by clicking an unfocusable area in an item or selecting it with a key movement. Clicking on a focusable widget inside an item will couse this particular item to get focus as usual.

References elm_obj_genlist_focus_on_selection_set.

Eina_Bool elm_genlist_highlight_mode_get | ( | const Evas_Object * | obj | ) |

Get whether the genlist items' should be highlighted when item selected.

Parameters

  obj | The genlist object.

Returns
  `EINA_TRUE` means items can be highlighted. `EINA_FALSE` indicates they can't. If `obj` is `NULL`, `EINA_FALSE` is returned.

See Also
  elm_genlist_highlight_mode_set() for details.

References elm_obj_genlist_highlight_mode_get.

void elm_genlist_highlight_mode_set | ( | Evas_Object * | obj,
|  | Eina_Bool | highlight
| ) |  |

Set whether the genlist items' should be highlighted when item selected.

Parameters

  obj | The genlist object.
  highlight | `EINA_TRUE` to enable highlighting or `EINA_FALSE` to disable it.

This will turn on/off the highlight effect when item selection and they will, or will not highlighted. The selected and clicked callback functions will still be called.

Highlight is enabled by default.

See Also
  elm_genlist_highlight_mode_get().

References elm_obj_genlist_highlight_mode_set.

Eina_Bool elm_genlist_homogeneous_get | ( | const Evas_Object * | obj | ) |

Get whether the homogeneous mode is enabled.

Parameters

  obj | The genlist object

Returns
  Assume the items within the genlist are of the same height and width (EINA_TRUE = on, EINA_FALSE = off)

See Also
  elm_genlist_homogeneous_set()

References elm_obj_genlist_homogeneous_get.

void elm_genlist_homogeneous_set | ( | Evas_Object * | obj,
|  | Eina_Bool | homogeneous
| ) |  |

Enable/disable homogeneous mode.

Parameters

  obj | The genlist object
  homogeneous | Assume the items within the genlist are of the same height and width (EINA_TRUE = on, EINA_FALSE = off). Default is `EINA_FALSE`.

This will enable the homogeneous mode where items are of the same height and width so that genlist may do the lazy-loading at its maximum (which increases the performance for scrolling the list). In the normal mode, genlist will pre-calculate all the items' sizes even though they are not in use. So items' callbacks are called many times than expected. But homogeneous mode will skip the item size pre-calculation process so items' callbacks are called only when the item is needed.

Note
  This also works well with group index.

See Also
  elm_genlist_mode_set()
  elm_genlist_homogeneous_get()

References elm_obj_genlist_homogeneous_set.

void elm_genlist_item_all_contents_unset | ( | Elm_Object_Item * | it,
|  | Eina_List ** | l
| ) |  |

Unset all contents fetched by the item class.

Parameters

  it | The item
  l | The contents list to return

This instructs genlist to release references to contents in the item, meaning that they will no longer be managed by genlist and are floating "orphans" that can be re-used elsewhere if the user wants to.

Elm_Object_Item* elm_genlist_item_append | ( | Evas_Object * | obj,
|  | const Elm_Genlist_Item_Class * | itc,
|  | const void * | data,
|  | Elm_Object_Item * | parent,
|  | Elm_Genlist_Item_Type | type,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Append a new item in a given genlist widget.

Parameters

  obj | The genlist object
  itc | The item class for the item
  data | The item data
  parent | The parent item, or NULL if none
  type | Item type
  func | Convenience function called when the item is selected
  func_data | Data passed to `func` above.

Returns
  A handle to the item added or `NULL` if not possible

This adds the given item to the end of the list or the end of the children list if the `parent` is given.

See Also
  elm_genlist_item_prepend()
  elm_genlist_item_insert_before()
  elm_genlist_item_insert_after()
  elm_object_item_del()

References elm_obj_genlist_item_append.

void elm_genlist_item_bring_in | ( | Elm_Object_Item * | it,
|  | Elm_Genlist_Item_Scrollto_Type | type
| ) |  |

Animatedly bring in, to the visible area of a genlist, a given item on it.

Parameters

  it | The item to display
  type | The position to bring in, the given item to. Elm_Genlist_Item_Scrollto_Type

This causes genlist to jump to the given item `it` and show it (by animatedly scrolling), if it is not fully visible. This may use animation and take a some time to do so.

See Also
  elm_genlist_item_show()

References elm_scrollable_interface_region_bring_in.

void elm_genlist_item_class_free | ( | Elm_Genlist_Item_Class * | itc | ) |

Remove an item class in a given genlist widget.

Parameters

  itc | The itc to be removed.

This removes item class from the genlist widget. Whenever it has no more references to it, item class is going to be freed. Otherwise it just decreases its reference count.

See Also
  elm_genlist_item_class_new()
  elm_genlist_item_class_ref()
  elm_genlist_item_class_unref()

References elm_genlist_item_class_unref().

Referenced by elm_genlist_item_class_unref().

Elm_Genlist_Item_Class* elm_genlist_item_class_new | ( | void |  | ) |

Create a new genlist item class in a given genlist widget.

Returns
  New allocated genlist item class.

This adds genlist item class for the genlist widget. When adding an item, genlist_item_{append, prepend, insert} function needs item class of the item. Given callback parameters are used at retrieving {text, content} of added item. Set as NULL if it's not used. If there's no available memory, return can be NULL.

See Also
  elm_genlist_item_class_free()
  elm_genlist_item_append()

void elm_genlist_item_class_ref | ( | Elm_Genlist_Item_Class * | itc | ) |

Increments object reference count for the item class.

Parameters

  itc | The given item class object to reference

This API just increases its reference count for item class management.

See Also
  elm_genlist_item_class_unref()

void elm_genlist_item_class_unref | ( | Elm_Genlist_Item_Class * | itc | ) |

Decrements object reference count for the item class.

Parameters

  itc | The given item class object to reference

This API just decreases its reference count for item class management. Reference count can't be less than 0.

See Also
  elm_genlist_item_class_ref()
  elm_genlist_item_class_free()

References elm_genlist_item_class_free().

Referenced by elm_genlist_item_class_free().

Eina_Bool elm_genlist_item_cursor_engine_only_get | ( | const Elm_Object_Item * | it | ) |

Get if the (custom) cursor for a given genlist item is being searched in its theme, also, or is only relying on the rendering engine.

Parameters

  it | a genlist item

Returns
  `EINA_TRUE`, if cursors are being looked for only on those provided by the rendering engine, `EINA_FALSE` if they are being searched on the widget's theme, as well.

See Also
  elm_genlist_item_cursor_engine_only_set(), for more details

void elm_genlist_item_cursor_engine_only_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | engine_only
| ) |  |

Set if the (custom) cursor for a given genlist item should be searched in its theme, also, or should only rely on the rendering engine.

Parameters

  it | item with custom (custom) cursor already set on
  engine_only | Use `EINA_TRUE` to have cursors looked for only on those provided by the rendering engine, `EINA_FALSE` to have them searched on the widget's theme, as well.

Note
  This call is of use only if you've set a custom cursor for genlist items, with elm_genlist_item_cursor_set().
  By default, cursors will only be looked for between those provided by the rendering engine.

const char* elm_genlist_item_cursor_get | ( | const Elm_Object_Item * | it | ) |

Get the type of mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given genlist widget item.

Parameters

  it | genlist item with custom cursor set

Returns
  the cursor type's name or `NULL`, if no custom cursors were set to `item` (and on errors)

See Also
  elm_object_cursor_get()
  elm_genlist_item_cursor_set() for more details
  elm_genlist_item_cursor_unset()

void elm_genlist_item_cursor_set | ( | Elm_Object_Item * | it,
|  | const char * | cursor
| ) |  |

Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given genlist widget item.

Parameters

  it | genlist item to customize cursor on
  cursor | the cursor type's name

This function works analogously as elm_object_cursor_set(), but here the cursor's changing area is restricted to the item's area, and not the whole widget's. Note that that item cursors have precedence over widget cursors, so that a mouse over `item` will always show cursor `type`.

If this function is called twice for an object, a previously set cursor will be unset on the second call.

See Also
  elm_object_cursor_set()
  elm_genlist_item_cursor_get()
  elm_genlist_item_cursor_unset()

const char* elm_genlist_item_cursor_style_get | ( | const Elm_Object_Item * | it | ) |

Get the current style set for a given genlist item's custom cursor.

Parameters

  it | genlist item with custom cursor set.

Returns
  style the cursor style in use. If the object does not have a cursor set, then `NULL` is returned.

See Also
  elm_genlist_item_cursor_style_set() for more details

void elm_genlist_item_cursor_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Set a different style for a given custom cursor set for a genlist item.

Parameters

  it | genlist item with custom cursor set
  style | the theme style to use (e.g. `"default"`, `"transparent"`, etc)

This function only makes sense when one is using custom mouse cursor decorations defined in a theme file , which can have, given a cursor name/type, alternate styles on it. It works analogously as elm_object_cursor_style_set(), but here applied only to genlist item objects.

Warning
  Before you set a cursor style you should have defined a custom cursor previously on the item, with elm_genlist_item_cursor_set()

See Also
  elm_genlist_item_cursor_engine_only_set()
  elm_genlist_item_cursor_style_get()

void elm_genlist_item_cursor_unset | ( | Elm_Object_Item * | it | ) |

Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given genlist widget item, thus making it show the default cursor again.

Parameters

  it | a genlist item

Use this call to undo any custom settings on this item's cursor decoration, bringing it back to defaults (no custom style set).

See Also
  elm_object_cursor_unset()
  elm_genlist_item_cursor_set() for more details

const char* elm_genlist_item_decorate_mode_get | ( | const Elm_Object_Item * | it | ) |

Get the item's decorate mode.

Parameters

  it | The genlist item

This function just returns the name of the item's decorate mode.

See Also
  elm_genlist_item_decorate_mode_set()
  elm_genlist_decorated_item_get()

void elm_genlist_item_decorate_mode_set | ( | Elm_Object_Item * | it,
|  | const char * | decorate_it_type,
|  | Eina_Bool | decorate_it_set
| ) |  |

Activate a genlist mode on an item.

Parameters

  it | The genlist item
  decorate_it_type | Mode name
  decorate_it_set | Boolean to define set or unset mode.

A genlist mode is a different way of selecting an item. Once a mode is activated on an item, any other selected item is immediately unselected. This feature provides an easy way of implementing a new kind of animation for selecting an item, without having to entirely rewrite the item style theme. However, the elm_genlist_selected_* API can't be used to get what item is activate for a mode.

The current item style will still be used, but applying a genlist mode to an item will select it using a different kind of animation.

The current active item for a mode can be found by elm_genlist_decorated_item_get().

The characteristics of genlist mode are:

- Only one mode can be active at any time, and for only one item.
- Genlist handles deactivating other items when one item is activated.
- A mode is defined in the genlist theme (edc), and more modes can easily be added.
- A mode style and the genlist item style are different things. They can be combined to provide a default style to the item, with some kind of animation for that item when the mode is activated.

When a mode is activated on an item, a new view for that item is created. The theme of this mode defines the animation that will be used to transit the item from the old view to the new view. This second (new) view will be active for that item while the mode is active on the item, and will be destroyed after the mode is totally deactivated from that item.

See Also
  elm_genlist_mode_get()
  elm_genlist_decorated_item_get()

References elm_genlist_item_selected_set(), and elm_genlist_selected_item_get().

void elm_genlist_item_demote | ( | Elm_Object_Item * | it | ) |

Demote an item to the end of the list.

Parameters

  it | The item

References elm_genlist_last_item_get().

int elm_genlist_item_expanded_depth_get | ( | const Elm_Object_Item * | it | ) |

Get the depth of expanded item.

Parameters

  it | The genlist item object

Returns
  The depth of expanded item

Eina_Bool elm_genlist_item_expanded_get | ( | const Elm_Object_Item * | it | ) |

Get the expanded state of an item.

Parameters

  it | The item

Returns
  The expanded state

This gets the expanded state of an item.

See Also
  elm_genlist_item_expanded_set()

void elm_genlist_item_expanded_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | expanded
| ) |  |

Sets the expanded state of an item.

Parameters

  it | The item
  expanded | The expanded state (`EINA_TRUE` expanded, `EINA_FALSE` not expanded).

This function flags the item of type ELM_GENLIST_ITEM_TREE as expanded or not.

The theme will respond to this change visually, and a signal "expanded" or "contracted" will be sent from the genlist with a pointer to the item that has been expanded/contracted.

Calling this function won't show or hide any child of this item (if it is a parent). You must manually delete and create them on the callbacks of the "expanded" or "contracted" signals.

See Also
  elm_genlist_item_expanded_get()

References ELM_GENLIST_ITEM_TREE.

void elm_genlist_item_fields_update | ( | Elm_Object_Item * | it,
|  | const char * | parts,
|  | Elm_Genlist_Item_Field_Type | itf
| ) |  |

Update the part of an item.

Parameters

  it | The item
  parts | The name of item's part
  itf | The type of item's part type

This updates an item's part by calling item's fetching functions again to get the contents, texts and states. Use this when the original item data has changed and the changes are desired to be reflected. Second parts argument is used for globbing to match '*', '?', and '.' It can be used at updating multi fields.

Use elm_genlist_realized_items_update() to update an item's all property.

See Also
  elm_genlist_item_update()

References ELM_GENLIST_ITEM_NONE, and elm_object_focus_allow_get().

Eina_Bool elm_genlist_item_flip_get | ( | const Elm_Object_Item * | it | ) |

Get the flip state of a given genlist item.

Parameters

  it | The genlist item object

This function returns the flip state of a given genlist item. If the parameter is invalid, it returns EINA_FALSE.

See Also
  elm_genlist_item_flip_set()

void elm_genlist_item_flip_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | flip
| ) |  |

Set the flip state of a given genlist item.

Parameters

  it | The genlist item object
  flip | The flip mode (EINA_TRUE = on, EINA_FALSE = off)

This function sets the flip state of a given genlist item. Flip mode overrides current item object. It can be used for on-the-fly item replace. Flip mode can be used with/without decorate mode.

See Also
  elm_genlist_item_flip_get()

References elm_genlist_item_update().

int elm_genlist_item_index_get | ( | const Elm_Object_Item * | it | ) |

Get the index of the item.

It is only valid once displayed.

Parameters

  it | a genlist item

Returns
  the position inside the list of item.

Elm_Object_Item* elm_genlist_item_insert_after | ( | Evas_Object * | obj,
|  | const Elm_Genlist_Item_Class * | itc,
|  | const void * | data,
|  | Elm_Object_Item * | parent,
|  | Elm_Object_Item * | after,
|  | Elm_Genlist_Item_Type | type,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert an item after another in a genlist widget.

Parameters

  obj | The genlist object
  itc | The item class for the item
  data | The item data
  parent | The parent item, or NULL if none
  after | The item to place this new one after.
  type | Item type
  func | Convenience function called when the item is selected
  func_data | Data passed to `func` above.

Returns
  A handle to the item added or `NULL` if not possible

This inserts an item after another in the list. It will be in the same tree level or group as the item it is inserted after.

See Also
  elm_genlist_item_append()
  elm_genlist_item_prepend()
  elm_genlist_item_insert_before()
  elm_object_item_del()

References elm_obj_genlist_item_insert_after.

Elm_Object_Item* elm_genlist_item_insert_before | ( | Evas_Object * | obj,
|  | const Elm_Genlist_Item_Class * | itc,
|  | const void * | data,
|  | Elm_Object_Item * | parent,
|  | Elm_Object_Item * | before,
|  | Elm_Genlist_Item_Type | type,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert an item before another in a genlist widget.

Parameters

  obj | The genlist object
  itc | The item class for the item
  data | The item data
  parent | The parent item, or NULL if none
  before | The item to place this new one before.
  type | Item type
  func | Convenience function called when the item is selected
  func_data | Data passed to `func` above.

Returns
  A handle to the item added or `NULL` if not possible

This inserts an item before another in the list. It will be in the same tree level or group as the item it is inserted before.

See Also
  elm_genlist_item_append()
  elm_genlist_item_prepend()
  elm_genlist_item_insert_after()
  elm_object_item_del()

References elm_obj_genlist_item_insert_before.

const Elm_Genlist_Item_Class* elm_genlist_item_item_class_get | ( | const Elm_Object_Item * | it | ) |

Get the Genlist Item class for the given Genlist Item.

Parameters

  it | The genlist item

This returns the Genlist_Item_Class for the given item. It can be used to examine the function pointers and item_style.

void elm_genlist_item_item_class_update | ( | Elm_Object_Item * | it,
|  | const Elm_Genlist_Item_Class * | itc
| ) |  |

Update the item class of an item.

Parameters

  it | The item
  itc | The item class for the item

This sets another class of the item, changing the way that it is displayed. After changing the item class, elm_genlist_item_update() is called on the item `it`.

References elm_genlist_item_update().

Elm_Object_Item* elm_genlist_item_next_get | ( | const Elm_Object_Item * | it | ) |

Get the next item in a genlist widget's internal list of items, given a handle to one of those items.

Parameters

  it | The genlist item to fetch next from

Returns
  The item after `item`, or `NULL` if there's none (and on errors)

This returns the item placed after the `item`, on the container genlist.

See Also
  elm_genlist_item_prev_get()

Elm_Object_Item* elm_genlist_item_parent_get | ( | const Elm_Object_Item * | it | ) |

Get the parent item of the given item.

Parameters

  it | The item

Returns
  The parent of the item or `NULL` if it has no parent.

This returns the item that was specified as parent of the item `it` on elm_genlist_item_append() and insertion related functions.

Elm_Object_Item* elm_genlist_item_prepend | ( | Evas_Object * | obj,
|  | const Elm_Genlist_Item_Class * | itc,
|  | const void * | data,
|  | Elm_Object_Item * | parent,
|  | Elm_Genlist_Item_Type | type,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Prepend a new item in a given genlist widget.

Parameters

  obj | The genlist object
  itc | The item class for the item
  data | The item data
  parent | The parent item, or NULL if none
  type | Item type
  func | Convenience function called when the item is selected
  func_data | Data passed to `func` above.

Returns
  A handle to the item added or NULL if not possible

This adds an item to the beginning of the list or beginning of the children of the parent if given.

See Also
  elm_genlist_item_append()
  elm_genlist_item_insert_before()
  elm_genlist_item_insert_after()
  elm_object_item_del()

References elm_obj_genlist_item_prepend.

Elm_Object_Item* elm_genlist_item_prev_get | ( | const Elm_Object_Item * | it | ) |

Get the previous item in a genlist widget's internal list of items, given a handle to one of those items.

Parameters

  it | The genlist item to fetch previous from

Returns
  The item before `item`, or `NULL` if there's none (and on errors)

This returns the item placed before the `item`, on the container genlist.

See Also
  elm_genlist_item_next_get()

void elm_genlist_item_promote | ( | Elm_Object_Item * | it | ) |

Promote an item to the top of the list.

Parameters

  it | The item

References elm_genlist_first_item_get().

Elm_Object_Select_Mode elm_genlist_item_select_mode_get | ( | const Elm_Object_Item * | it | ) |

Get the genlist item's select mode.

Parameters

  it | The genlist item object

Returns
  The select mode (If getting mode is failed, it returns ELM_OBJECT_SELECT_MODE_MAX)

See Also
  elm_genlist_item_select_mode_set()

void elm_genlist_item_select_mode_set | ( | Elm_Object_Item * | it,
|  | Elm_Object_Select_Mode | mode
| ) |  |

Set the genlist item's select mode.

Parameters

  it | The genlist item object
  mode | The select mode

elm_genlist_select_mode_set() changes item's select mode.

- ELM_OBJECT_SELECT_MODE_DEFAULT : The item will only call their selection func and callback when first becoming selected. Any further clicks will do nothing, unless you set always select mode.
- ELM_OBJECT_SELECT_MODE_ALWAYS : This means that, even if selected, every click will make the selected callbacks be called.
- ELM_OBJECT_SELECT_MODE_NONE : This will turn off the ability to select the item entirely and they will neither appear selected nor call selected callback functions.
- ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY : This will apply no-finger-size rule with ELM_OBJECT_SELECT_MODE_NONE. No-finger-size rule makes an item can be smaller than lower limit. Clickable objects should be bigger than human touch point device (your finger) for some touch or small screen devices. So it is enabled, the item can be shrink than predefined finger-size value. And the item will be updated.

See Also
  elm_genlist_item_select_mode_get()

References ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY.

Eina_Bool elm_genlist_item_selected_get | ( | const Elm_Object_Item * | it | ) |

Get whether a given genlist item is selected or not.

Parameters

  it | The item

Returns
  `EINA_TRUE`, if it's selected, `EINA_FALSE` otherwise

See Also
  elm_genlist_item_selected_set() for more details

void elm_genlist_item_selected_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | selected
| ) |  |

Set whether a given genlist item is selected or not.

Parameters

  it | The item
  selected | Use `EINA_TRUE`, to make it selected, `EINA_FALSE` to make it unselected

This sets the selected state of an item. If multi selection is not enabled on the containing genlist and `selected` is `EINA_TRUE`, any other previously selected items will get unselected in favor of this new one.

See Also
  elm_genlist_item_selected_get()

Referenced by elm_genlist_item_decorate_mode_set().

void elm_genlist_item_show | ( | Elm_Object_Item * | it,
|  | Elm_Genlist_Item_Scrollto_Type | type
| ) |  |

Show the portion of a genlist's internal list containing a given item, immediately.

Parameters

  it | The item to display
  type | The position to bring in, the given item to. Elm_Genlist_Item_Scrollto_Type

This causes genlist to jump to the given item `it` and show it (by jumping to that position), if it is not fully visible.

See Also
  elm_genlist_item_bring_in()

References elm_scrollable_interface_content_region_show.

Elm_Object_Item* elm_genlist_item_sorted_insert | ( | Evas_Object * | obj,
|  | const Elm_Genlist_Item_Class * | itc,
|  | const void * | data,
|  | Elm_Object_Item * | parent,
|  | Elm_Genlist_Item_Type | type,
|  | Eina_Compare_Cb | comp,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert a new item into the sorted genlist object.

Parameters

  obj | The genlist object
  itc | The item class for the item
  data | The item data
  parent | The parent item, or NULL if none
  type | Item type
  comp | The function called for the sort
  func | Convenience function called when item selected
  func_data | Data passed to `func` above.

Returns
  A handle to the item added or NULL if not possible

This inserts an item in the genlist based on user defined comparison function. The two arguments passed to the function `func` are genlist item handles to compare.

See Also
  elm_genlist_item_append()
  elm_genlist_item_prepend()
  elm_genlist_item_insert_after()
  elm_object_item_del()

References elm_obj_genlist_item_sorted_insert.

void elm_genlist_item_subitems_clear | ( | Elm_Object_Item * | it | ) |

Remove all sub-items (children) of the given item.

Parameters

  it | The item

This removes all items that are children (and their descendants) of the given item `it`.

See Also
  elm_genlist_clear()
  elm_object_item_del()

void elm_genlist_item_tooltip_content_cb_set | ( | Elm_Object_Item * | it,
|  | Elm_Tooltip_Item_Content_Cb | func,
|  | const void * | data,
|  | Evas_Smart_Cb | del_cb
| ) |  |

Set the content to be shown in a given genlist item's tooltips.

Parameters

  it | The genlist item.
  func | The function returning the tooltip contents.
  data | What to provide to func as callback data/context.
  del_cb | Called when data is not needed anymore, either when another callback replaces `func`, the tooltip is unset with elm_genlist_item_tooltip_unset() or the owner `item` dies. This callback receives as its first parameter the given `data`, being `event_info` the item handle.

This call will setup the tooltip's contents to `item` (analogous to elm_object_tooltip_content_cb_set(), but being item tooltips with higher precedence than object tooltips). It can have only one tooltip at a time, so any previous tooltip content will get removed. `func` (with `data`) will be called every time Elementary needs to show the tooltip and it should return a valid Evas object, which will be fully managed by the tooltip system, getting deleted when the tooltip is gone.

In order to set just a text as a tooltip, look at elm_genlist_item_tooltip_text_set().

Referenced by elm_genlist_item_tooltip_text_set().

const char* elm_genlist_item_tooltip_style_get | ( | const Elm_Object_Item * | it | ) |

Get the style set a given genlist item's tooltip.

Parameters

  it | genlist item with tooltip already set on.

Returns
  style the theme style in use, which defaults to "default". If the object does not have a tooltip set, then `NULL` is returned.

See Also
  elm_genlist_item_tooltip_style_set() for more details

References elm_object_item_tooltip_style_get().

void elm_genlist_item_tooltip_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Set a different style for a given genlist item's tooltip.

Parameters

  it | genlist item with tooltip set
  style | the theme style to use on tooltips (e.g. `"default"`, `"transparent"`, etc)

Tooltips can have alternate styles to be displayed on, which are defined by the theme set on Elementary. This function works analogously as elm_object_tooltip_style_set(), but here applied only to genlist item objects. The default style for tooltips is `"default"`.

Note
  before you set a style you should define a tooltip with elm_genlist_item_tooltip_content_cb_set() or elm_genlist_item_tooltip_text_set()

See Also
  elm_genlist_item_tooltip_style_get()

Referenced by elm_genlist_item_tooltip_unset().

void elm_genlist_item_tooltip_text_set | ( | Elm_Object_Item * | it,
|  | const char * | text
| ) |  |

Set the text to be shown in a given genlist item's tooltips.

Parameters

  it | The genlist item
  text | The text to set in the content

This call will setup the text to be used as tooltip to that item (analogous to elm_object_tooltip_text_set(), but being item tooltips with higher precedence than object tooltips). It can have only one tooltip at a time, so any previous tooltip data will get removed.

In order to set a content or something else as a tooltip, look at elm_genlist_item_tooltip_content_cb_set().

References elm_genlist_item_tooltip_content_cb_set().

void elm_genlist_item_tooltip_unset | ( | Elm_Object_Item * | it | ) |

Unset a tooltip from a given genlist item.

Parameters

  it | genlist item to remove a previously set tooltip from.

This call removes any tooltip set on `item`. The callback provided as `del_cb` to elm_genlist_item_tooltip_content_cb_set() will be called to notify it is not used anymore (and have resources cleaned, if need be).

See Also
  elm_genlist_item_tooltip_content_cb_set()

References elm_genlist_item_tooltip_style_set().

Elm_Genlist_Item_Type elm_genlist_item_type_get | ( | const Elm_Object_Item * | it | ) |

Get the Item's Type.

Parameters

  it | The genlist item

Returns
  The item type.

This function returns the item's type. Normally the item's type. If it failed, return value is ELM_GENLIST_ITEM_MAX

void elm_genlist_item_update | ( | Elm_Object_Item * | it | ) |

Update all the contents of an item.

Parameters

  it | The item

This updates an item by calling all the item class functions again to get the contents, texts and states. Use this when the original item data has changed and the changes are desired to be reflected.

Use elm_genlist_realized_items_update() to update all already realized items.

Note
  This also updates internal genlist item object(edje_object as of now). So when this is called between mouse down and mouse up, mouse up event will be ignored because edje_object is deleted and created again by this API. If you want to avoid this, please use elm_genlist_item_fields_update.

See Also
  elm_genlist_realized_items_update()

Referenced by elm_genlist_item_flip_set(), and elm_genlist_item_item_class_update().

unsigned int elm_genlist_items_count | ( | const Evas_Object * | obj | ) |

Return how many items are currently in a list.

Parameters

  obj | The list

Returns
  The total number of list items in the list

This behavior is O(1) and includes items which may or may not be realized.

References elm_obj_genlist_items_count.

Elm_Object_Item* elm_genlist_last_item_get | ( | const Evas_Object * | obj | ) |

Get the last item in the genlist.

This returns the last item in the list.

Returns
  The last item, or NULL if none

References elm_obj_genlist_last_item_get.

Referenced by elm_genlist_item_demote().

double elm_genlist_longpress_timeout_get | ( | const Evas_Object * | obj | ) |

Get the timeout in seconds for the longpress event.

Parameters

  obj | The genlist object

Returns
  timeout in seconds

See Also
  elm_genlist_longpress_timeout_get()

References elm_obj_genlist_longpress_timeout_get.

void elm_genlist_longpress_timeout_set | ( | Evas_Object * | obj,
|  | double | timeout
| ) |  |

Set the timeout in seconds for the longpress event.

Parameters

  obj | The genlist object
  timeout | timeout in seconds. Default is elm config value(1.0)

This option will change how long it takes to send an event "longpressed" after the mouse down signal is sent to the list. If this event occurs, no "clicked" event will be sent.

Warning
  If you set the longpress timeout value with this API, your genlist will not be affected by the longpress value of elementary config value later.

See Also
  elm_genlist_longpress_timeout_set()

References elm_obj_genlist_longpress_timeout_set.

Elm_List_Mode elm_genlist_mode_get | ( | const Evas_Object * | obj | ) |

Get the horizontal stretching mode.

Parameters

  obj | The genlist object

Returns
  The mode to use (ELM_LIST_LIMIT, ELM_LIST_SCROLL)

See Also
  elm_genlist_mode_set()

References ELM_LIST_LAST, and elm_obj_genlist_mode_get.

void elm_genlist_mode_set | ( | Evas_Object * | obj,
|  | Elm_List_Mode | mode
| ) |  |

This sets the horizontal stretching mode.

Parameters

  obj | The genlist object
  mode | The mode to use (one of ELM_LIST_SCROLL or ELM_LIST_LIMIT).

This sets the mode used for sizing items horizontally. Valid modes are ELM_LIST_LIMIT, ELM_LIST_SCROLL, and ELM_LIST_COMPRESS. The default is ELM_LIST_SCROLL. This mode means that if items are too wide to fit, the scroller will scroll horizontally. Otherwise items are expanded to fill the width of the viewport of the scroller. If it is ELM_LIST_LIMIT, items will be expanded to the viewport width and limited to that size. If it is ELM_LIST_COMPRESS, the item width will be fixed (restricted to a minimum of) to the list width when calculating its size in order to allow the height to be calculated based on it. This allows, for instance, text block to wrap lines if the Edje part is configured with "text.min: 0 1".

Note
  ELM_LIST_COMPRESS will make list resize slower as it will have to recalculate every item height again whenever the list width changes!
  Homogeneous mode is for that all items in the genlist same width/height. With ELM_LIST_COMPRESS, it makes genlist items to fast initializing. However there's no sub-objects in genlist which can be on the flying resizable (such as TEXTBLOCK). If then, some dynamic resizable objects in genlist would not diplayed properly.

See Also
  elm_genlist_mode_get()

References elm_obj_genlist_mode_set.

Eina_Bool elm_genlist_multi_select_get | ( | const Evas_Object * | obj | ) |

Get if multi-selection in genlist is enabled or disabled.

Parameters

  obj | The genlist object

Returns
  Multi-select enabled/disabled (`EINA_TRUE` = enabled/`EINA_FALSE` = disabled). Default is `EINA_FALSE`.

See Also
  elm_genlist_multi_select_set()

References elm_obj_genlist_multi_select_get.

Elm_Object_Multi_Select_Mode elm_genlist_multi_select_mode_get | ( | const Evas_Object * | obj | ) |

Get the genlist multi select mode.

Parameters

  obj | The genlist object

Returns
  The multi select mode (If getting mode is failed, it returns ELM_OBJECT_MULTI_SELECT_MODE_MAX)

See Also
  elm_genlist_multi_select_set()
  elm_genlist_multi_select_mode_set()

Since
  1.8

References elm_obj_genlist_multi_select_mode_get.

void elm_genlist_multi_select_mode_set | ( | Evas_Object * | obj,
|  | Elm_Object_Multi_Select_Mode | mode
| ) |  |

Set the genlist multi select mode.

Parameters

  obj | The genlist object
  mode | The multi select mode

- ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT : select/unselect items whenever each item is clicked.
- ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL : Only one item will be selected although multi-selection is enabled, if clicked without pressing control key. This mode is only available with multi-selection.

See Also
  elm_genlist_multi_select_set()
  elm_genlist_multi_select_mode_get()

Since
  1.8

References elm_obj_genlist_multi_select_mode_set.

void elm_genlist_multi_select_set | ( | Evas_Object * | obj,
|  | Eina_Bool | multi
| ) |  |

Enable or disable multi-selection in the genlist.

Parameters

  obj | The genlist object
  multi | Multi-select enable/disable. Default is disabled.

This enables (`EINA_TRUE`) or disables (`EINA_FALSE`) multi-selection in the list. This allows more than 1 item to be selected. To retrieve the list of selected items, use elm_genlist_selected_items_get().

See Also
  elm_genlist_selected_items_get()
  elm_genlist_multi_select_get()

References elm_obj_genlist_multi_select_set.

Eina_List* elm_genlist_realized_items_get | ( | const Evas_Object * | obj | ) |

Get a list of realized items in genlist.

Parameters

  obj | The genlist object

Returns
  The list of realized items, nor NULL if none are realized.

This returns a list of the realized items in the genlist. The list contains genlist item pointers. The list must be freed by the caller when done with eina_list_free(). The item pointers in the list are only valid so long as those items are not deleted or the genlist is not deleted.

See Also
  elm_genlist_realized_items_update()

References elm_obj_genlist_realized_items_get.

void elm_genlist_realized_items_update | ( | Evas_Object * | obj | ) |

Update the contents of all realized items.

Parameters

  obj | The genlist object.

This updates all realized items by calling all the item class functions again to get the contents, texts and states. Use this when the original item data has changed and the changes are desired to be reflected.

To update just one item, use elm_genlist_item_update().

See Also
  elm_genlist_realized_items_get()
  elm_genlist_item_update()

References elm_obj_genlist_realized_items_update.

Eina_Bool elm_genlist_reorder_mode_get | ( | const Evas_Object * | obj | ) |

Get the reorder mode.

Parameters

  obj | The genlist object

Returns
  The reorder mode (EINA_TRUE = on, EINA_FALSE = off)

References elm_obj_genlist_reorder_mode_get.

void elm_genlist_reorder_mode_set | ( | Evas_Object * | obj,
|  | Eina_Bool | reorder_mode
| ) |  |

Set reorder mode.

Parameters

  obj | The genlist object
  reorder_mode | The reorder mode (EINA_TRUE = on, EINA_FALSE = off)

After turning on the reorder mode, longpress on normal item will trigger reordering of the item. You can move the item up and down. However, reorder does not work with group item.

References elm_obj_genlist_reorder_mode_set.

EINA_DEPRECATED void elm_genlist_scroller_policy_get | ( | const Evas_Object * | obj,
|  | Elm_Scroller_Policy * | policy_h,
|  | Elm_Scroller_Policy * | policy_v
| ) |  |

Get the scrollbar policy.

Parameters

  obj | The genlist object
  policy_h | Pointer to store the horizontal scrollbar policy.
  policy_v | Pointer to store the vertical scrollbar policy.

Deprecated:
  Use elm_scroller_policy_get() instead.

See Also
  elm_scroller_policy_get()

References elm_scrollable_interface_policy_get.

EINA_DEPRECATED void elm_genlist_scroller_policy_set | ( | Evas_Object * | obj,
|  | Elm_Scroller_Policy | policy_h,
|  | Elm_Scroller_Policy | policy_v
| ) |  |

Set the scrollbar policy.

Parameters

  obj | The genlist object
  policy_h | Horizontal scrollbar policy.
  policy_v | Vertical scrollbar policy.

This sets the scrollbar visibility policy for the given genlist scroller. #ELM_SCROLLER_POLICY_AUTO means the scrollbar is made visible if it is needed, and otherwise kept hidden. #ELM_SCROLLER_POLICY_ON turns it on all the time, and #ELM_SCROLLER_POLICY_OFF always keeps it off. This applies respectively for the horizontal and vertical scrollbars. Default is #ELM_SCROLLER_POLICY_AUTO

Deprecated:
  Use elm_scroller_policy_set() instead.

See Also
  elm_scroller_policy_set()

References elm_scrollable_interface_policy_set.

Elm_Object_Select_Mode elm_genlist_select_mode_get | ( | const Evas_Object * | obj | ) |

Get the genlist select mode.

Parameters

  obj | The genlist object

Returns
  The select mode (If getting mode is failed, it returns ELM_OBJECT_SELECT_MODE_MAX)

See Also
  elm_genlist_select_mode_set()

References elm_obj_genlist_select_mode_get.

void elm_genlist_select_mode_set | ( | Evas_Object * | obj,
|  | Elm_Object_Select_Mode | mode
| ) |  |

Set the genlist select mode.

Parameters

  obj | The genlist object
  mode | The select mode

elm_genlist_select_mode_set() changes item select mode in the genlist widget.

- ELM_OBJECT_SELECT_MODE_DEFAULT : Items will call their selection func and callback once when first becoming selected. Any further clicks will do nothing, unless you set always select mode.
- ELM_OBJECT_SELECT_MODE_ALWAYS : This means that, even if selected, every click will make the selected callbacks be called.
- ELM_OBJECT_SELECT_MODE_NONE : This will turn off the ability to select items entirely and they will neither appear selected nor call selected callback functions.

See Also
  elm_genlist_select_mode_get()

References elm_obj_genlist_select_mode_set.

Elm_Object_Item* elm_genlist_selected_item_get | ( | const Evas_Object * | obj | ) |

Get the selected item in the genlist.

Parameters

  obj | The genlist object

Returns
  The selected item, or NULL if none is selected.

This gets the selected item in the list (if multi-selection is enabled, only the item that was first selected in the list is returned - which is not very useful, so see elm_genlist_selected_items_get() for when multi-selection is used).

If no item is selected, NULL is returned.

See Also
  elm_genlist_selected_items_get()

References elm_obj_genlist_selected_item_get.

Referenced by elm_genlist_item_decorate_mode_set().

const Eina_List* elm_genlist_selected_items_get | ( | const Evas_Object * | obj | ) |

Get a list of selected items in the genlist.

Parameters

  obj | The genlist object

Returns
  The list of selected items, or NULL if none are selected.

It returns a list of the selected items. This list pointer is only valid so long as the selection doesn't change (no items are selected or unselected, or unselected implicitly by deletion). The list contains genlist items pointers. The order of the items in this list is the order which they were selected, i.e. the first item in this list is the first item that was selected, and so on.

Note
  If not in multi-select mode, consider using function elm_genlist_selected_item_get() instead.

See Also
  elm_genlist_multi_select_set()
  elm_genlist_selected_item_get()

References elm_obj_genlist_selected_items_get.

Eina_Bool elm_genlist_tree_effect_enabled_get | ( | const Evas_Object * | obj | ) |

Get Genlist tree effect.

Parameters

  obj | The genlist object

Returns
  The tree effect status (EINA_TRUE = enabled, EINA_FALSE = disabled

References elm_obj_genlist_tree_effect_enabled_get.

void elm_genlist_tree_effect_enabled_set | ( | Evas_Object * | obj,
|  | Eina_Bool | enabled
| ) |  |

Set Genlist tree effect.

Parameters

  obj | The genlist object
  enabled | The tree effect status (EINA_TRUE = enabled, EINA_FALSE = disabled

References elm_obj_genlist_tree_effect_enabled_set.

Copyright ©2000-2014 Enlightenment.org - Samsung Electronics supports the EFL Documentation Project - Generated Wed Jan 8 2014 20:51:13